/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the AppAuthorizerPinterestStaticPinterestStaticAuthorizerNewRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &AppAuthorizerPinterestStaticPinterestStaticAuthorizerNewRequest{}

// AppAuthorizerPinterestStaticPinterestStaticAuthorizerNewRequest struct for AppAuthorizerPinterestStaticPinterestStaticAuthorizerNewRequest
type AppAuthorizerPinterestStaticPinterestStaticAuthorizerNewRequest struct {
	Service *string                       `json:"service,omitempty"`
	Data    *PinterestStaticDtoAuthorizer `json:"data,omitempty"`
}

// NewAppAuthorizerPinterestStaticPinterestStaticAuthorizerNewRequest instantiates a new AppAuthorizerPinterestStaticPinterestStaticAuthorizerNewRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewAppAuthorizerPinterestStaticPinterestStaticAuthorizerNewRequest() *AppAuthorizerPinterestStaticPinterestStaticAuthorizerNewRequest {
	this := AppAuthorizerPinterestStaticPinterestStaticAuthorizerNewRequest{}
	var service string = "pinterest_static"
	this.Service = &service
	return &this
}

// NewAppAuthorizerPinterestStaticPinterestStaticAuthorizerNewRequestWithDefaults instantiates a new AppAuthorizerPinterestStaticPinterestStaticAuthorizerNewRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewAppAuthorizerPinterestStaticPinterestStaticAuthorizerNewRequestWithDefaults() *AppAuthorizerPinterestStaticPinterestStaticAuthorizerNewRequest {
	this := AppAuthorizerPinterestStaticPinterestStaticAuthorizerNewRequest{}
	var service string = "pinterest_static"
	this.Service = &service
	return &this
}

// GetService returns the Service field value if set, zero value otherwise.
func (o *AppAuthorizerPinterestStaticPinterestStaticAuthorizerNewRequest) GetService() string {
	if o == nil || IsNil(o.Service) {
		var ret string
		return ret
	}
	return *o.Service
}

// GetServiceOk returns a tuple with the Service field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AppAuthorizerPinterestStaticPinterestStaticAuthorizerNewRequest) GetServiceOk() (*string, bool) {
	if o == nil || IsNil(o.Service) {
		return nil, false
	}
	return o.Service, true
}

// HasService returns a boolean if a field has been set.
func (o *AppAuthorizerPinterestStaticPinterestStaticAuthorizerNewRequest) HasService() bool {
	if o != nil && !IsNil(o.Service) {
		return true
	}

	return false
}

// SetService gets a reference to the given string and assigns it to the Service field.
func (o *AppAuthorizerPinterestStaticPinterestStaticAuthorizerNewRequest) SetService(v string) {
	o.Service = &v
}

// GetData returns the Data field value if set, zero value otherwise.
func (o *AppAuthorizerPinterestStaticPinterestStaticAuthorizerNewRequest) GetData() PinterestStaticDtoAuthorizer {
	if o == nil || IsNil(o.Data) {
		var ret PinterestStaticDtoAuthorizer
		return ret
	}
	return *o.Data
}

// GetDataOk returns a tuple with the Data field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AppAuthorizerPinterestStaticPinterestStaticAuthorizerNewRequest) GetDataOk() (*PinterestStaticDtoAuthorizer, bool) {
	if o == nil || IsNil(o.Data) {
		return nil, false
	}
	return o.Data, true
}

// HasData returns a boolean if a field has been set.
func (o *AppAuthorizerPinterestStaticPinterestStaticAuthorizerNewRequest) HasData() bool {
	if o != nil && !IsNil(o.Data) {
		return true
	}

	return false
}

// SetData gets a reference to the given PinterestStaticDtoAuthorizer and assigns it to the Data field.
func (o *AppAuthorizerPinterestStaticPinterestStaticAuthorizerNewRequest) SetData(v PinterestStaticDtoAuthorizer) {
	o.Data = &v
}

func (o AppAuthorizerPinterestStaticPinterestStaticAuthorizerNewRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o AppAuthorizerPinterestStaticPinterestStaticAuthorizerNewRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Service) {
		toSerialize["service"] = o.Service
	}
	if !IsNil(o.Data) {
		toSerialize["data"] = o.Data
	}
	return toSerialize, nil
}

type NullableAppAuthorizerPinterestStaticPinterestStaticAuthorizerNewRequest struct {
	value *AppAuthorizerPinterestStaticPinterestStaticAuthorizerNewRequest
	isSet bool
}

func (v NullableAppAuthorizerPinterestStaticPinterestStaticAuthorizerNewRequest) Get() *AppAuthorizerPinterestStaticPinterestStaticAuthorizerNewRequest {
	return v.value
}

func (v *NullableAppAuthorizerPinterestStaticPinterestStaticAuthorizerNewRequest) Set(val *AppAuthorizerPinterestStaticPinterestStaticAuthorizerNewRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableAppAuthorizerPinterestStaticPinterestStaticAuthorizerNewRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableAppAuthorizerPinterestStaticPinterestStaticAuthorizerNewRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableAppAuthorizerPinterestStaticPinterestStaticAuthorizerNewRequest(val *AppAuthorizerPinterestStaticPinterestStaticAuthorizerNewRequest) *NullableAppAuthorizerPinterestStaticPinterestStaticAuthorizerNewRequest {
	return &NullableAppAuthorizerPinterestStaticPinterestStaticAuthorizerNewRequest{value: val, isSet: true}
}

func (v NullableAppAuthorizerPinterestStaticPinterestStaticAuthorizerNewRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableAppAuthorizerPinterestStaticPinterestStaticAuthorizerNewRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
